/*
/////////////////////[ How to use this code to set DeviceID and PSS ]////////////////////////////
  1) change the ID value below "#define ID  (0)"(If you are testing our demo, 
     then set them according to our device ID table)
  2) Compile and download to your Propeller board (P0),
     if the ID and PSS is set successfully, the module will turn to green after about 5 seconds 
///////////////////////////////////////////////////////////////////////////////////////////////////

*/


#include <propeller.h>
#include "RGB_LED_MATRIX_GCC.h"


#define    RGB_LED_MATRIX_SIO   (0) /* P0 connect to RGB LED module*/




///////////////////////////////////[ Only this one need to be changed ]//////////////////
#define ID (1)        /* Please change the ID you need for 4 module please set to 0/1/16/17 for each module*/
/////////////////////////////////////////////////////////////////////////////////////
#define PSS (15)      /* RSS = (PSS + 1) * 8 = 128,  Real Screen Size = (PSS + 1) * 8 */






/* You don't need to read to code below */






















































#define BOUND_SX ((ID%(PSS+1))*8)
#define BOUND_SY ((ID/(PSS+1))*8)
#define BOUND_EX (BOUND_SX+7)
#define BOUND_EY (BOUND_SY+7)


int main(void)
{
    signed int index = 0;
    char cbuffer[4] = {0x00, 0xFF, 0x00, 0x00};    
    RGB_LED_MATRIX_start(1,RGB_LED_MATRIX_SIO,  0, 19200); /* Initialize the serial port*/
    
    waitcnt(CLKFREQ + CNT);
    
    RGB_LED_MATRIX_change_device_id(ID);
    RGB_LED_MATRIX_change_screen_size(PSS);
    waitcnt(CLKFREQ/20 + CNT);
    
    RGB_LED_MATRIX_change_device_id(ID);
    RGB_LED_MATRIX_change_screen_size(PSS);
    RGB_LED_MATRIX_reset(); 
      
      
    waitcnt(CLKFREQ*3 + CNT);    

    
   RGB_LED_MATRIX_clear_screen(0x000000FF); 
   
   RGB_LED_MATRIX_set_window(BOUND_SX,BOUND_SY,BOUND_EX,BOUND_EY);
   RGB_LED_MATRIX_tx_data_length(8*8*3);
   
   for(index = 0; index < 8*8 ; index++)
   {
         RGB_LED_MATRIX_tx_color_data(cbuffer, 3);   
   }
   
   RGB_LED_MATRIX_update_screen();
   
   while(1)
   {
   
   }    
    
    return 0;
}        