/*
*************************************************************************************
**
**                             
**
** Files      : Serial_Driver_Xbuff_Low_Level.c
**
** Version : 1.0
**
** Date     : 2012/04/19
**
** Description:
**
**
** History:
**    1. Date: 2012/04/19
**       Author: John Zhong
**       Modification: Create
**
****************************************************************************************
*/

#include "Serial_Driver_Xbuff_Low_Level.h"

static HUBDATA int sdllcog = 0;
static HUBDATA serial_driver_struct sds;

long serial_driver_llstart(int rxpin, int txpin, int rxtxmode, int baud_rate)
{
    extern unsigned int *binary_Serial_Driver_Xbuff_Low_Level_dat_start;
    serial_driver_llstop(); 
    
    sds.rx_pin = rxpin;
    sds.tx_pin = txpin;
    sds.rxtx_mode = rxtxmode;
    sds.bit_ticks = CLKFREQ / baud_rate;
    sds.buffer_ptr = (int)&sds.rx_buffer;

    sdllcog = cognew(&binary_Serial_Driver_Xbuff_Low_Level_dat_start, (int *) &sds) + 1;
    waitcnt( CLKFREQ / 100 + CNT ) ;
    return sdllcog;
}

void serial_driver_llstop(void)
{
    int cog = sdllcog - 1;
    if(sdllcog > 0)
    {
        cogstop(cog);
        sdllcog = 0;
    }
}

int serial_check(void)
{
    int rxbyte = 0xFFFFFFFF;
    if (sds.rx_tail != sds.rx_head)
    {
        rxbyte = sds.rx_buffer[sds.rx_tail];
        sds.rx_tail = (sds.rx_tail + 1) & SERIAL_BUFFER_MASK;
    }
    return rxbyte;
}

void serial_flush(void)
{
    while (serial_check() >= 0)
    {
     }
}

int serial_rxtime(int ms)
{
    int rxbyte = 0xFFFFFFFF;
    int onems = CLKFREQ / 1000;
    int t = CNT;
    while ((rxbyte < 0) || ((CNT - t) / onems) >= ms)
    {
        rxbyte = serial_check();
    }
    return rxbyte;
}

int serial_rx(void)
{
    int rxbyte = 0xFFFFFFFF;    
    while( rxbyte < 0)
    {
        rxbyte = serial_check();
    }
    return rxbyte;
}

void serial_tx(int txbyte)
{
    while(((sds.tx_head + 1) & SERIAL_BUFFER_MASK) == sds.tx_tail)
    {
    }
    sds.tx_buffer[sds.tx_head] = (char) txbyte;
    sds.tx_head = (sds.tx_head + 1) & SERIAL_BUFFER_MASK;
}

void serial_tx_dec(int dec_value)
{
    int j;
    unsigned int res = 0x01;
    signed int i;
    signed int x;
    x = (dec_value == 0x80000000);
    if (dec_value < 0)
    {
        dec_value = 0 - (dec_value + x);
        serial_tx('-');
    }
    i = 1000000000;
    for(j = 0; j < 10;  j++)
    {
        if(dec_value >= i)
        {
            serial_tx((dec_value / i) + '0' +(x * (i == 1)));
            dec_value %= i;
            res = 0x0;
        }
        else if((res == 0x0) || (i ==1))
        {
                serial_tx('0');
        }
        i /= 10;
    }
    

}
