/*
*************************************************************************************
**
**                             
**
** Files      : Serial_Driver_Xbuff_Low_Level.h
**
** Version : 1.0
**
** Date     : 2012/04/19
**
** Description:
**
**
** History:
**    1. Date: 2012/04/19
**       Author: John Zhong
**       Modification: Create
**
****************************************************************************************
*/

#ifndef SERIAL_DRIVER_XBUFF_LOW_LEVEL_H

#define SERIAL_DRIVER_XBUFF_LOW_LEVEL_H
#include <propeller.h>

#define SERIAL_BUFFER_SIZE (512)            // make sure this value is the same as the one (bufsiz) in the spin file
#define SERIAL_BUFFER_MASK (SERIAL_BUFFER_SIZE - 1)

typedef struct serialdriver_struct
{
    long rx_head;
    long rx_tail;
    long tx_head;
    long tx_tail;
    long rx_pin;
    long tx_pin;
    long rxtx_mode;
    long bit_ticks;
    long buffer_ptr;
    char rx_buffer[SERIAL_BUFFER_SIZE];
    char tx_buffer[SERIAL_BUFFER_SIZE];
} serial_driver_struct;


long serial_driver_llstart(int rxpin, int txpin, int mode, int baud_rate);
void serial_driver_llstop(void);
int serial_rxcheck(void);
void serial_rxflush(void);
int serial_rxtime(int ms);
int serial_rx(void);
void serial_tx(int txbyte);
void serial_tx_dec(int dec_value);

#endif // SERIAL_DRIVER_XBUFF_LOW_LEVEL_H